Subject: Re: [PATCH net] net: macb: fix a memory corruption in extended buffer descriptor mode

From: Jakub Kicinski <[email-masked]>
Date: Tue, 11 Apr 2023 21:13:43 -0700

On Tue, 11 Apr 2023 20:48:50 -0700 Roman Gushchin wrote:
> > diff --git a/drivers/net/ethernet/cadence/macb_main.c
> > b/drivers/net/ethernet/cadence/macb_main.c
> > index d13fb1d31821..1a40d5a26f36 100644
> > --- a/drivers/net/ethernet/cadence/macb_main.c
> > +++ b/drivers/net/ethernet/cadence/macb_main.c
> > @@ -1042,6 +1042,10 @@ static dma_addr_t macb_get_addr(struct macb *bp,
> > struct macb_dma_desc *desc)
> >         }
> >  #endif
> >         addr |= MACB_BF(RX_WADDR, MACB_BFEXT(RX_WADDR, desc->addr));
> > +#ifdef CONFIG_MACB_USE_HWSTAMP
> > +       if (bp->hw_dma_cap & HW_DMA_CAP_PTP)
> > +               addr &= ~GEM_BIT(DMA_RXVALID_OFFSET);
> > +#endif
> >         return addr;
> >  }
> 
> I think this version is slightly worse because it adds an unconditional
> if statement, which can be removed with certain config options.
> I can master a version with a helper function, if it's preferable.
> 
> But if you like this one, it's fine too, let me know, I'll send an updated
> version.

Yup, IMHO this looks better. More likely that someone reading the code
will spot the trickiness.

I suspect we could clear that bit unconditionally, if the branch is 
a concern. The code seems to assume that buffers it gets are 8B aligned
already, regardless of CONFIG_MACB_USE_HWSTAMP.

Drivers commonly save the DMA address to a SW ring (here I think
rx_skbuff plays this role but only holds single ptr per entry)
so that they don't have to access potentially uncached descriptor
ring. But that'd be too large of a change for a fix.